package com.sichaos.OWLAPI;

import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.io.RDFXMLOntologyFormat;
import org.semanticweb.owlapi.io.SystemOutDocumentTarget;
import org.semanticweb.owlapi.model.*;
import org.semanticweb.owlapi.reasoner.BufferingMode;
import org.semanticweb.owlapi.reasoner.NodeSet;
import org.semanticweb.owlapi.reasoner.OWLReasoner;
import org.semanticweb.owlapi.reasoner.SimpleConfiguration;
import org.semanticweb.owlapi.reasoner.structural.StructuralReasoner;
import org.semanticweb.owlapi.util.DefaultPrefixManager;
import org.semanticweb.owlapi.util.OWLEntityRemover;
import org.semanticweb.owlapi.util.OWLOntologyMerger;

import uk.ac.manchester.cs.owlapi.modularity.ModuleType;
import uk.ac.manchester.cs.owlapi.modularity.SyntacticLocalityModuleExtractor;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.io.File;
import java.net.URI;

import javax.swing.text.html.HTMLDocument.Iterator;

public class modifyMyOntology {

	/**
	 * This code can achieve many operations on my ontology. You can read, write, modify etc.
	 * @throws OWLOntologyStorageException 
	 */
	public static void main(String[] args) throws OWLOntologyStorageException {
		// 
		try{
			OWLOntologyManager manager = OWLManager.createOWLOntologyManager();
			OWLDataFactory factory = manager.getOWLDataFactory();
			IRI iri = IRI.create("file:///D:/Study/Softwares/StudySoftwares/Protege_3.4.8/HyperMusic.owl");
			
			//load ontology Hypermusic.owl
			OWLOntology ont = manager.loadOntologyFromOntologyDocument(iri);
			System.out.println("IndividualsInSignature"+ ont.getIndividualsInSignature());
			System.out.println("ClassesInSignature"+ ont.getClassesInSignature()+"\n");
			
			//save ontology Hypermusic
			File file = new File("/C:/Users/Sichao Song/Desktop/HypermusicModified.owl");
			manager.saveOntology(ont, IRI.create(file.toURI()));
						
			//entities
			OWLClass cls = factory.getOWLClass(iri);
			//System.out.println(cls.getIndividualsInSignature());
			PrefixManager pm = new DefaultPrefixManager("file:///D:/Study/Softwares/StudySoftwares/Protege_3.4.8/HyperMusic#");
            OWLClass clsModified = factory.getOWLClass(":OntologyModified", pm);
            
            OWLOntology ontology = manager.createOntology(IRI.create("file:///D:/Study/Softwares/StudySoftwares/Protege_3.4.8/HyperMusic"));
            OWLDeclarationAxiom declarationAxiom = factory.getOWLDeclarationAxiom(clsModified);
            manager.addAxiom(ontology, declarationAxiom);
            manager.saveOntology(ontology, new SystemOutDocumentTarget());
            File file1 = new File("/C:/Users/Sichao Song/Desktop/HypermusicModified_1.owl");
			manager.saveOntology(ont, IRI.create(file.toURI()));
            manager.saveOntology(ontology, IRI.create(file1.toURI()));
            System.out.println(declarationAxiom+"\n");
            
            //classes and instances
            OWLClass player = factory.getOWLClass(":Player", pm);
            OWLNamedIndividual song = factory.getOWLNamedIndividual(":SongSichao", pm);
            OWLClassAssertionAxiom classAssertion = factory.getOWLClassAssertionAxiom(player, song);
            manager.addAxiom(ontology, classAssertion);
            File file2 = new File("/C:/Users/Sichao Song/Desktop/HypermusicModified_2.owl");
            manager.saveOntology(ontology, IRI.create(file2.toURI()));
            
            //delete entities
            OWLEntityRemover remover = new OWLEntityRemover(manager, Collections.singleton(ont));
            System.out.println("Number of individuals:(before deletion) " + ont.getIndividualsInSignature().size());
            for (OWLNamedIndividual ind : ont.getIndividualsInSignature()) {
                ind.accept(remover);
            }
            manager.applyChanges(remover.getChanges());
            System.out.println("Number of individuals:(after deletion) " + ont.getIndividualsInSignature().size()+"\n");
            remover.reset();
            File file3 = new File("/C:/Users/Sichao Song/Desktop/HypermusicModified_3.owl");
            manager.saveOntology(ont,IRI.create(file3.toURI()));
            
            //swrl rules
            
            //reasoning
            
            //merging ontologies
            OWLOntologyManager man = OWLManager.createOWLOntologyManager();
            man.loadOntologyFromOntologyDocument(IRI.create("http://www.co-ode.org/ontologies/pizza/pizza.owl"));
            man.loadOntologyFromOntologyDocument(IRI.create("file:///D:/Study/Softwares/StudySoftwares/Protege_3.4.8/HyperMusic.owl"));
            OWLOntologyMerger merger = new OWLOntologyMerger(man);
            IRI mergedOntologyIRI = IRI.create("http://www.semanticweb.com/mymergedont");
            OWLOntology merged = merger.createMergedOntology(man, mergedOntologyIRI);
            File file4 = new File("/C:/Users/Sichao Song/Desktop/HypermusicModified_4.owl");
            man.saveOntology(merged, IRI.create(file4.toURI()));
            
            //module extraction
            System.out.println("Loaded: " + ont.getOntologyID());
            OWLClass currentMusic = factory.getOWLClass(IRI.create(ont.getOntologyID().getOntologyIRI().toString() + "#CurrentMusic"));
            System.out.println("IRI.create(ont.getOntologyID().getOntologyIRI().toString(): " + IRI.create(ont.getOntologyID().getOntologyIRI().toString()));
            Set<OWLEntity> sig = new HashSet<OWLEntity>();
            sig.add(currentMusic);
            for(java.util.Iterator<OWLEntity> i = sig.iterator(); i.hasNext();){
            	System.out.println(i.next());
            }
            Set<OWLEntity> seedSig = new HashSet<OWLEntity>();
            //OWLReasoner reasoner = new StructuralReasoner(ont, new SimpleConfiguration(), BufferingMode.NON_BUFFERING);
            OWLReasoner reasoner = new StructuralReasoner(ont, new SimpleConfiguration(), BufferingMode.NON_BUFFERING);
            for (OWLEntity ent : sig) {
                seedSig.add(ent);
                if (OWLClass.class.isAssignableFrom(ent.getClass())) {
                    NodeSet<OWLClass> subClasses = reasoner.getSubClasses((OWLClass) ent, false);
                    seedSig.addAll(subClasses.getFlattened());
                }
            }
            System.out.println("Extracting the module for the seed signature consisting of the following entities:");
            for (OWLEntity ent : seedSig) {
                System.out.println("  " + ent);
            }
            SyntacticLocalityModuleExtractor sme = new SyntacticLocalityModuleExtractor(man, ont, ModuleType.STAR);
            File file5 = new File("/C:/Users/Sichao Song/Desktop/HypermusicModified_5.owl");
            OWLOntology mod = sme.extractAsOntology(seedSig, IRI.create("file:///D:/Study/Softwares/StudySoftwares/Protege_3.4.8/HyperMusic"));
            System.out.println("Saving the module as " + mod.getOntologyID().getOntologyIRI() + " .");
            man.saveOntology(mod, IRI.create(file5.toURI()));
			
		}
		catch (OWLOntologyCreationException e) {
            System.out.println("Could not load ontology: " + e.getMessage());
		}
		catch (OWLOntologyStorageException e) {
            System.out.println("Could not save ontology: " + e.getMessage());
        }
		
	}

}
